DELIMITER $$

USE `crib`$$

DROP PROCEDURE IF EXISTS `dbsize`$$

CREATE PROCEDURE `dbsize`(hostnamein VARCHAR(60), portin int, dbnamein VARCHAR(60))
BEGIN
          
      set @com=concat('set @INSTID=(SELECT ID FROM info_instances WHERE hostname like "%' , hostnamein , '%" AND PORT=' , portin , ' order by rand() limit 1 );');
      prepare command from @com;
      execute command;
      
      if length(dbnamein) = 0 then
	 set dbnamein=('%');
      END IF;
      
      SELECT date_time, db_name,tb_name,data_size,index_size,data_index_size,data_free,ROW_COUNT 
      FROM info_object_size 
	 WHERE instance_id=@INSTID AND 
	 db_name like dbnamein AND 
	 DATE(date_time)=(
	    SELECT DATE(MAX(date_time)) 
	    FROM info_object_size 
	       WHERE instance_id=@INSTID AND 
	       db_name like dbnamein
         )
         order by 2 asc, 4 desc;
      	
END $$
DELIMITER ;

DELIMITER $$

USE `crib`$$

DROP PROCEDURE IF EXISTS `finddatabase`$$

CREATE PROCEDURE `finddatabase`(dbnamein varchar(60))
BEGIN
          
      SELECT m.hostname AS MACHINE_NAME, m.port AS PORT, o.db_name AS `DATABASE`
      FROM info_objects o, info_instances m
	 WHERE o.db_name like dbnamein 
	 AND o.instance_id=m.id 
	 GROUP BY m.port, m.hostname
	 ORDER BY 1 ASC, 2 ASC;
	 
END $$
DELIMITER ;

DELIMITER $$

USE `crib`$$

DROP PROCEDURE IF EXISTS `finduser`$$

CREATE PROCEDURE `finduser`(usernamein varchar(16))
BEGIN
          
      SELECT m.hostname AS MACHINE_NAME, m.port AS PORT, u.username AS USERNAME, u.hostname AS HOSTNAME
      FROM info_users u, info_instances m
	 WHERE u.username=usernamein 
	 AND u.instance_id=m.id;
	 
END $$
DELIMITER ;

DELIMITER $$

USE `crib`$$

DROP PROCEDURE IF EXISTS `userpassword`$$

CREATE PROCEDURE `userpassword`()
BEGIN
          
      select m.hostname as MACHINE_NAME, m.port as port, u.username as USERNAME, u.hostname as HOSTNAME, IF(STRCMP(u.password,PASSWORD(u.username)),'Empty Password','Password = Username') as PASSWORD
      FROM info_users u, info_instances m
	 WHERE ( u.password='' or u.password=PASSWORD(u.username) ) 
	 and u.instance_id=m.id;
	 
END $$
DELIMITER ;

