DELIMITER $$

USE `crib`$$

DROP PROCEDURE IF EXISTS `info_user_privileges`$$

CREATE PROCEDURE `info_user_privileges`(INSTANCEID INT)
BEGIN
        DECLARE HOST_NAME VARCHAR(60);
        DECLARE PORT_NUM INT;
        DECLARE OS_TYPE VARCHAR(15);
        DECLARE OS_ARCH VARCHAR(20);
        DECLARE MYSQL_VERSION_NUM VARCHAR(10);
        DECLARE SERVER_ID_NUM INT;
        DECLARE dbcount INT;
        DECLARE MACHINE_EXISTS INT;
        DECLARE USER_ID MEDIUMINT;
        DECLARE usernamein VARCHAR(16);
        DECLARE hostnamein VARCHAR(60);
        DECLARE usernameathostname VARCHAR(85);
        DECLARE grants_list TEXT;
        DECLARE done INT DEFAULT 0;
        
        DECLARE cur_priv CURSOR FOR
            SELECT  username,hostname
            FROM crib.info_users
                WHERE instance_id=INSTANCEID;
                
        DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
        
        OPEN cur_priv;
            cur_priv_loop:WHILE(done=0) DO
                FETCH cur_priv INTO usernamein, hostnamein;
                IF done=1 THEN
                   LEAVE cur_priv_loop;
                END IF;
                SET usernameathostname= CONCAT("'" , usernamein , "'@'" , hostnamein , "'");
                SET USER_ID=(SELECT id FROM crib.info_users WHERE `username`=usernamein AND `hostname`=hostnamein AND instance_id=INSTANCEID);
                SET dbcount = (
                    SELECT COUNT(*)
                    FROM user_privilege_list
                        WHERE TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",2))=usernamein
                            AND TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",-2))=hostnamein
                            LIMIT 1
                    );
                    
                dbcount_loop:WHILE(dbcount > 0) DO
                    SET @db=(
                        SELECT table_schema
                        FROM user_privilege_list
                            WHERE #grantee=\"usernameathostname\"
                            TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",2))=usernamein
                            AND TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",-2))=hostnamein
                            LIMIT 1
                        );
                        
                    SET @privs=(
			SELECT `privileges` 
			FROM user_privilege_list 
			   WHERE TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",2))=usernamein
                           AND TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",-2))=hostnamein
                           AND table_schema=@db);
                           
                    INSERT INTO crib.info_privileges VALUES (INSTANCEID,USER_ID,@db,@privs);
                    DELETE FROM user_privilege_list WHERE grantee=usernameathostname AND table_schema=@db ;
                    SET dbcount = (
                        SELECT COUNT(*)
                        FROM user_privilege_list
                            WHERE TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",2))=usernamein
                            AND TRIM(BOTH "'" FROM SUBSTRING_INDEX(grantee,"'",-2))=hostnamein
                            LIMIT 1
                        );
                        
                END WHILE dbcount_loop;
            END WHILE cur_priv_loop;
        CLOSE cur_priv;
END$$

DELIMITER ;
